--
-- warn level watcher for combines, seeder, sprayer and motorized
-- by Blacky_BPG
-- Version 4.1.7
--

warningsCombine = {};
warningsCombine.modDir = g_currentModDirectory;

function warningsCombine.prerequisitesPresent(specializations)
	return true;
end;

function warningsCombine:load(xmlFile)
	if g_currentMission.accidentWarnings == nil then
		g_currentMission.accidentWarnings = {};
	end;
	local name = getXMLString(xmlFile, "vehicle.name.de");
	name = Utils.getNoNil(name, getXMLString(xmlFile, "vehicle.name.en"));
	name = Utils.getNoNil(getXMLString(xmlFile, "vehicle.name"), name);
	name = Utils.getNoNil(name,getXMLString(xmlFile, "vehicle#type"));
	self.name = name;
	local addMe = true;
	self.fixDisabler = false;
	for a,b in pairs(g_currentMission.accidentWarnings) do
		if b ~= nil and b.id ~= nil and b.id == self.id then
			addMe = false;
		end;
	end;
	self.tablePositionCB = -1;
	if addMe == true then
		local tbl = {};
		tbl.id = self.id;
		tbl.name = self.name;
		tbl.fuel = 100;
		tbl.oil = 100;
		tbl.grain = 0;
		tbl.seed = 100;
		tbl.fert = 100;
		table.insert(g_currentMission.accidentWarnings,tbl);
	end;
	self.pointerCB = 0;
	for a,b in pairs(g_currentMission.accidentWarnings) do
		if b ~= nil and b.id ~= nil and b.id == self.id then
			self.tablePositionCB = a;
			break;
		end;
	end;
end;

function warningsCombine:delete()
	if self.tablePositionCB ~= nil and self.tablePositionCB > -1 then
		local b = g_currentMission.accidentWarnings[self.tablePositionCB]
		if b.id ~= nil and b.id == self.id then
			b.oil = 100;
			b.grain = 0;
			b.fuel = 100;
			b.fert = 100;
			b.seed = 100;
			b.name = "deleted";
		end;
	end;
end;

function warningsCombine:readStream(streamId, connection)
end;

function warningsCombine:writeStream(streamId, connection)
end;

function warningsCombine:mouseEvent(posX, posY, isDown, isUp, button)
end;

function warningsCombine:keyEvent(unicode, sym, modifier, isDown)
end;

function warningsCombine:update(dt)
	if (self.warningsDisabled ~= nil and not self.warningsDisabled) or self.warningsDisabled == nil then
		self.fixDisabler = false;
		if self.pointerCB >= 5 then
			self.pointerCB = 0;
			if self.grainTankCapacity ~= nil and self.grainTankCapacity > 0 and self.tablePositionCB ~= nil and self.tablePositionCB > -1 then
				local tmp = math.floor((100 / self.grainTankCapacity * self.grainTankFillLevel) * 10) / 10;
				if tmp > 80 then
					local b = g_currentMission.accidentWarnings[self.tablePositionCB]
					if b.id ~= nil and b.id == self.id then
						b.grain = tmp;
					end;
				end;
			end;
		else
			self.pointerCB = self.pointerCB + 1;
		end;
	else
		if not self.fixDisabler then
			self.fixDisabler = true;
			if self.tablePositionCB ~= nil and self.tablePositionCB > -1 then
				local b = g_currentMission.accidentWarnings[self.tablePositionCB]
				if b.id ~= nil and b.id == self.id then
					b.grain = 0;
				end;
			end;
		end;
	end;
end;

function warningsCombine:updateTick(dt)
end;

function warningsCombine:onLeave()
end;

function warningsCombine:onEnter()
end;

function warningsCombine:draw()
end;

warningsFertilizer = {};
warningsFertilizer.modDir = g_currentModDirectory;

function warningsFertilizer.prerequisitesPresent(specializations)
	return true;
end;

function warningsFertilizer:load(xmlFile)
	if g_currentMission.accidentWarnings == nil then
		g_currentMission.accidentWarnings = {};
	end;
	local name = getXMLString(xmlFile, "vehicle.name.de");
	name = Utils.getNoNil(name, getXMLString(xmlFile, "vehicle.name.en"));
	name = Utils.getNoNil(getXMLString(xmlFile, "vehicle.name"), name);
	name = Utils.getNoNil(name,getXMLString(xmlFile, "vehicle#type"));
	self.name = name;
	local addMe = true;
	self.fixDisabler = false;
	for a,b in pairs(g_currentMission.accidentWarnings) do
		if b ~= nil and b.id ~= nil and b.id == self.id then
			addMe = false;
		end;
	end;
	self.tablePositionFT = -1;
	if addMe == true then
		local tbl = {};
		tbl.id = self.id;
		tbl.name = self.name;
		tbl.fuel = 100;
		tbl.grain = 0;
		tbl.oil = 100;
		tbl.seed = 100;
		tbl.fert = 100;
		table.insert(g_currentMission.accidentWarnings,tbl);
	end;
	self.pointerFT = 0;
	for a,b in pairs(g_currentMission.accidentWarnings) do
		if b ~= nil and b.id ~= nil and b.id == self.id then
			self.tablePositionFT = a;
			break;
		end;
	end;
end;

function warningsFertilizer:delete()
	if self.tablePositionFT ~= nil and self.tablePositionFT > -1 then
		local b = g_currentMission.accidentWarnings[self.tablePositionFT]
		if b.id ~= nil and b.id == self.id then
			b.oil = 100;
			b.grain = 0;
			b.fuel = 100;
			b.fert = 100;
			b.seed = 100;
			b.name = "deleted";
		end;
	end;
end;

function warningsFertilizer:readStream(streamId, connection)
end;

function warningsFertilizer:writeStream(streamId, connection)
end;

function warningsFertilizer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function warningsFertilizer:keyEvent(unicode, sym, modifier, isDown)
end;

function warningsFertilizer:update(dt)
	if (self.warningsDisabled ~= nil and not self.warningsDisabled) or self.warningsDisabled == nil then
		self.fixDisabler = false;
		if self.pointerFT >= 5 then
			self.pointerFT = 0;
			if self.capacity ~= nil and self.capacity > 0 and self.tablePositionFT ~= nil and self.tablePositionFT > -1 then
				local tmp = math.floor((100 / self.capacity * self.fillLevel) * 10) / 10;
				local b = g_currentMission.accidentWarnings[self.tablePositionFT]
				if b.id ~= nil and b.id == self.id and tmp < 20 then
					b.fert = tmp;
				end;
			end;
		else
			self.pointerFT = self.pointerFT + 1;
		end;
	else
		if not self.fixDisabler then
			self.fixDisabler = true;
			if self.tablePositionFT ~= nil and self.tablePositionFT > -1 then
				local b = g_currentMission.accidentWarnings[self.tablePositionFT]
				if b.id ~= nil and b.id == self.id then
					b.fert = 100;
				end;
			end;
		end;
	end;
end;

function warningsFertilizer:updateTick(dt)
end;

function warningsFertilizer:onLeave()
end;

function warningsFertilizer:onEnter()
end;

function warningsFertilizer:draw()
end;

warningsMotorized = {};
warningsMotorized.modDir = g_currentModDirectory;

function warningsMotorized.prerequisitesPresent(specializations)
	return true;
end;

function warningsMotorized:load(xmlFile)
	if g_currentMission.accidentWarnings == nil then
		g_currentMission.accidentWarnings = {};
	end;
	local name = getXMLString(xmlFile, "vehicle.name.de");
	name = Utils.getNoNil(name, getXMLString(xmlFile, "vehicle.name.en"));
	name = Utils.getNoNil(getXMLString(xmlFile, "vehicle.name"), name);
	name = Utils.getNoNil(name,getXMLString(xmlFile, "vehicle#type"));
	self.name = name;
	local addMe = true;
	self.fixDisabler = false;
	for a,b in pairs(g_currentMission.accidentWarnings) do
		if b ~= nil and b.id ~= nil and b.id == self.id then
			addMe = false;
		end;
	end;
	self.tablePositionMO = -1;
	if addMe == true then
		local tbl = {};
		tbl.id = self.id;
		tbl.name = self.name;
		tbl.fuel = 100;
		tbl.grain = 0;
		tbl.oil = 100;
		tbl.seed = 100;
		tbl.fert = 100;
		table.insert(g_currentMission.accidentWarnings,tbl);
	end;
	self.pointerMO = 0;
	for a,b in pairs(g_currentMission.accidentWarnings) do
		if b ~= nil and b.id ~= nil and b.id == self.id then
			self.tablePositionMO = a;
			break;
		end;
	end;
end;

function warningsMotorized:delete()
	if self.tablePositionMO ~= nil and self.tablePositionMO > -1 then
		local b = g_currentMission.accidentWarnings[self.tablePositionMO]
		if b.id ~= nil and b.id == self.id then
			b.oil = 100;
			b.grain = 0;
			b.fuel = 100;
			b.fert = 100;
			b.seed = 100;
			b.name = "deleted";
		end;
	end;
	self.pointerMO = 0;
end;

function warningsMotorized:readStream(streamId, connection)
end;

function warningsMotorized:writeStream(streamId, connection)
end;

function warningsMotorized:mouseEvent(posX, posY, isDown, isUp, button)
end;

function warningsMotorized:keyEvent(unicode, sym, modifier, isDown)
end;

function warningsMotorized:update(dt)
	if (self.warningsDisabled ~= nil and not self.warningsDisabled) or self.warningsDisabled == nil then
		self.fixDisabler = false;
		if self.pointerMO >= 5 then
			self.pointerMO = 0;
			if self.fuelCapacity ~= nil and self.fuelCapacity > 0 and self.tablePositionMO ~= nil and self.tablePositionMO > -1 then
				local tmp = math.floor((100 / self.fuelCapacity * self.fuelFillLevel) * 10) / 10;
				local b = g_currentMission.accidentWarnings[self.tablePositionMO]
				if b.id ~= nil and b.id == self.id and tmp < 20 then
					b.fuel = tmp;
				end;
			end;
		else
			self.pointerMO = self.pointerMO + 1;
		end;
	else
		if not self.fixDisabler then
			self.fixDisabler = true;
			if self.tablePositionMO ~= nil and self.tablePositionMO > -1 then
				local b = g_currentMission.accidentWarnings[self.tablePositionMO]
				if b.id ~= nil and b.id == self.id then
					b.fuel = 100;
				end;
			end;
		end;
	end;
end;

function warningsMotorized:updateTick(dt)
end;

function warningsMotorized:onLeave()
end;

function warningsMotorized:onEnter()
end;

function warningsMotorized:draw()
end;

warningsSeeder = {};
warningsSeeder.modDir = g_currentModDirectory;

function warningsSeeder.prerequisitesPresent(specializations)
	return true;
end;

function warningsSeeder:load(xmlFile)
	if g_currentMission.accidentWarnings == nil then
		g_currentMission.accidentWarnings = {};
	end;
	local name = getXMLString(xmlFile, "vehicle.name.de");
	name = Utils.getNoNil(name, getXMLString(xmlFile, "vehicle.name.en"));
	name = Utils.getNoNil(getXMLString(xmlFile, "vehicle.name"), name);
	name = Utils.getNoNil(name,getXMLString(xmlFile, "vehicle#type"));
	self.name = name;
	local addMe = true;
	self.fixDisabler = false;
	for a,b in pairs(g_currentMission.accidentWarnings) do
		if b ~= nil and b.id ~= nil and b.id == self.id then
			addMe = false;
		end;
	end;
	self.tablePositionSE = -1;
	if addMe == true then
		local tbl = {};
		tbl.id = self.id;
		tbl.name = self.name;
		tbl.fuel = 100;
		tbl.oil = 100;
		tbl.grain = 0;
		tbl.seed = 100;
		tbl.fert = 100;
		table.insert(g_currentMission.accidentWarnings,tbl);
	end;
	self.pointerSE = 0;
	for a,b in pairs(g_currentMission.accidentWarnings) do
		if b ~= nil and b.id ~= nil and b.id == self.id then
			self.tablePositionSE = a;
			break;
		end;
	end;
end;

function warningsSeeder:delete()
	if self.tablePositionSE ~= nil and self.tablePositionSE > -1 then
		local b = g_currentMission.accidentWarnings[self.tablePositionSE]
		if b.id ~= nil and b.id == self.id then
			b.oil = 100;
			b.grain = 0;
			b.fuel = 100;
			b.fert = 100;
			b.seed = 100;
			b.name = "deleted";
		end;
	end;
end;

function warningsSeeder:readStream(streamId, connection)
end;

function warningsSeeder:writeStream(streamId, connection)
end;

function warningsSeeder:mouseEvent(posX, posY, isDown, isUp, button)
end;

function warningsSeeder:keyEvent(unicode, sym, modifier, isDown)
end;

function warningsSeeder:update(dt)
	if (self.warningsDisabled ~= nil and not self.warningsDisabled) or self.warningsDisabled == nil then
		self.fixDisabler = false;
		if self.pointerSE >= 5 then
			self.pointerSE = 0;
			if self.capacity ~= nil and self.capacity > 0 and self.tablePositionSE ~= nil and self.tablePositionSE > -1 then
				local tmp = math.floor((100 / self.capacity * self.fillLevel) * 10) / 10;
				local b = g_currentMission.accidentWarnings[self.tablePositionSE]
				if b.id ~= nil and b.id == self.id and tmp < 20 then
					b.seed = tmp;
				end;
				local tmp2 = 100;
				if self.setIsFertilizing ~= nil and self.setSprayFillLevel ~= nil and self.sprayFillLevel ~= nil and self.sprayCapacity ~= nil then
					tmp2 = math.floor((100 / self.sprayCapacity * self.sprayFillLevel) * 10) / 10;
				end;
				if b.id ~= nil and b.id == self.id and tmp2 < 20 then
					b.fert = tmp2;
				end;
			end;
		else
			self.pointerSE = self.pointerSE + 1;
		end;
	else
		if not self.fixDisabler then
			self.fixDisabler = true;
			if self.tablePositionSE ~= nil and self.tablePositionSE > -1 then
				local b = g_currentMission.accidentWarnings[self.tablePositionSE]
				if b.id ~= nil and b.id == self.id then
					b.seed = 100;
					b.fert = 100;
				end;
			end;
		end;
	end;
end;

function warningsSeeder:updateTick(dt)
	-- URF Seeder Fix
	if self.setIsFertilizing ~= nil and self.setSprayFillLevel ~= nil then
		if self.isServer then
			if self:getIsHired() then
				if self.isFertilizing > 1 then
					local litersPerSecond = self.sprayLitersPerSecond;
					if self.isFertilizing == 2 then
						litersPerSecond = litersPerSecond / 2;
					end;
					local usage = litersPerSecond * dt*0.001;
					local sprayFillType = self.currentSprayFillType;
					local sprayFillTypeDesc = Fillable.fillTypeIndexToDesc[sprayFillType];
					if sprayFillTypeDesc ~= nil then
						local delta = usage*sprayFillTypeDesc.pricePerLiter;
						g_currentMission.missionStats.expensesTotal = g_currentMission.missionStats.expensesTotal - delta;
						g_currentMission.missionStats.expensesSession = g_currentMission.missionStats.expensesSession - delta;
						g_currentMission:addSharedMoney(delta, "other");
					end;
					if self.sprayFillLevel > 0 and self.fillLevel > 0 then
						self:setSprayFillLevel(self.sprayFillLevel - usage);
					else
						self:setIsFertilizing(1);
					end;
				end;
			end;
		end;
	end;
	-- URF Seeder Fix End
end;

function warningsSeeder:onLeave()
end;

function warningsSeeder:onEnter()
end;

function warningsSeeder:draw()
end;

warningsDisabler = {};
warningsDisabler.modDir = g_currentModDirectory;

function warningsDisabler.prerequisitesPresent(specializations)
	return true;
end;

function warningsDisabler:load(xmlFile)
	self.warningsDisabled = false;
	self.warningsSaveTimer = 0;
	self.warningsSaved = false;
	self.disableWarnings = SpecializationUtil.callSpecializationsFunction("disableWarnings");
end;

function warningsDisabler:delete()
end;

function warningsDisabler:readStream(streamId, connection)
     self:disableWarnings(streamReadBool(streamId), true);
end;

function warningsDisabler:writeStream(streamId, connection)
	streamWriteBool(streamId, self.warningsDisabled);
end;

function warningsDisabler:mouseEvent(posX, posY, isDown, isUp, button)
end;
function warningsDisabler:keyEvent(unicode, sym, modifier, isDown)
end;

function warningsDisabler:disableWarnings(state, noEventSend)
	self.warningsDisabled = state;
	warningsDisablerEvent.sendEvent(self, state, noEventSend);
end;

function warningsDisabler:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	local valueInt = Utils.getNoNil(getXMLBool(xmlFile, key.."#warningsDisabled"),self.warningsDisabled);
	self:disableWarnings(valueInt);
	return BaseMission.VEHICLE_LOAD_OK;
end;

function warningsDisabler:getSaveAttributesAndNodes(nodeIdent)
	local attributes = nil;
	if not self.warningsSaved then
		self.warningsSaved = true;
		attributes = 'warningsDisabled="'.. tostring(self.warningsDisabled) .. '"';
	end;
	return attributes, nil;
end;

function warningsDisabler:update(dt)
	if self:getIsActiveForInput(true) and self.isClient then
		if InputBinding.hasEvent(InputBinding.disableWarnings) then
			self:disableWarnings(not self.warningsDisabled);
		end;
	end;
	if self.warningsSaved then
		self.warningsSaveTimer = self.warningsSaveTimer + 1;
		if self.warningsSaveTimer >= 100 then
			self.warningsSaveTimer = 0;
			self.warningsSaved = false;
		end;
	end;
end;

function warningsDisabler:draw()
	if self:getIsActiveForInput(true) and self.isClient then
		g_currentMission:addHelpButtonText(g_i18n:getText("disableWarnings"), InputBinding.disableWarnings);
	end;
end;

warningsDisablerEvent = {};
warningsDisablerEvent_mt = Class(warningsDisablerEvent, Event);

InitEventClass(warningsDisablerEvent, "warningsDisablerEvent");

function warningsDisablerEvent:emptyNew()
	local self = Event:new(warningsDisablerEvent_mt );
	self.className="warningsDisablerEvent";
	return self;
end;

function warningsDisablerEvent:new(vehicle, state)
	self.vehicle = vehicle;
	self.state = state;
	return self;
end;

function warningsDisablerEvent:readStream(streamId, connection)
	local id = streamReadInt32(streamId);
	self.state = streamReadBool(streamId);
	self.vehicle = networkGetObject(id);
	self:run(connection);
end;

function warningsDisablerEvent:writeStream(streamId, connection)
	streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteBool(streamId, self.state );
end;

function warningsDisablerEvent:run(connection)
	if self.vehicle ~= nil then
		if not connection:getIsServer() then
			g_server:broadcastEvent(warningsDisablerEvent:new(self.vehicle, self.state), nil, connection, self.vehicle);
		end;
		if self.vehicle.disableWarnings ~= nil then
			self.vehicle:disableWarnings(self.state, true);
		end;
	end;
end;

function warningsDisablerEvent.sendEvent(vehicle, state, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(warningsDisablerEvent:new(vehicle, state), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(warningsDisablerEvent:new(vehicle, state));
		end;
	end;
end;

