SpecializationUtil.registerSpecialization("warningsCombine", "warningsCombine", g_currentModDirectory.."AccidentWarnings.lua");
SpecializationUtil.registerSpecialization("warningsSeeder", "warningsSeeder", g_currentModDirectory.."AccidentWarnings.lua");
SpecializationUtil.registerSpecialization("warningsMotorized", "warningsMotorized", g_currentModDirectory.."AccidentWarnings.lua");
SpecializationUtil.registerSpecialization("warningsFertilizer", "warningsFertilizer", g_currentModDirectory.."AccidentWarnings.lua");
SpecializationUtil.registerSpecialization("warningsDisabler", "warningsDisabler", g_currentModDirectory.."AccidentWarnings.lua");

WarningFunctions = {};
WarningFunctions.modDir = g_currentModDirectory;

function WarningFunctions:loadMap(name)
	if self.firstRun == nil then
		self.firstRun = false;
		g_currentMission.extraHudMode = 0;
		g_i18n.globalI18N.texts["diesel"] = g_i18n:getText("diesel");
		g_i18n.globalI18N.texts["grain"] = g_i18n:getText("grain");
		g_i18n.globalI18N.texts["seed"] = g_i18n:getText("seed");
		g_i18n.globalI18N.texts["oilWarning"] = g_i18n:getText("oilWarning");
		g_i18n.globalI18N.texts["fert"] = g_i18n:getText("fert");
		for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
			if v ~= nil and not SpecializationUtil.hasSpecialization(TrafficVehicle, v.specializations) then
				for i = 1, table.maxn(v.specializations) do
				  local vs = v.specializations[i];
				  if vs ~= nil then
					if vs == SpecializationUtil.getSpecialization("motorized") then
						local allowInsertion2 = true;
						local v_name_string = v.name;
						local point_location = string.find(v_name_string, ".", nil, true);
						if point_location ~= nil then
							local ModFileName = string.sub(v_name_string, 1, point_location-1);
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.warningsMotorized", ModFileName)), v.specializations) then
								allowInsertion2 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.WarningsMotorized", ModFileName)), v.specializations) then
								allowInsertion2 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.Warningsmotorized", ModFileName)), v.specializations) then
								allowInsertion2 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.warningsmotorized", ModFileName)), v.specializations) then
								allowInsertion2 = false;
							end;

						end;
						if allowInsertion2 then
							table.insert(v.specializations, SpecializationUtil.getSpecialization("warningsMotorized"));
							table.insert(v.specializations, SpecializationUtil.getSpecialization("warningsDisabler"));
						end;
					end;
					if vs == SpecializationUtil.getSpecialization("sowingMachine") then
						local allowInsertion12 = true;
						local v_name_string = v.name
						local point_location = string.find(v_name_string, ".", nil, true)
						if point_location ~= nil then
							local ModFileName = string.sub(v_name_string, 1, point_location-1);
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.warningsSeeder", ModFileName)), v.specializations) then
								allowInsertion12 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.WarningsSeeder", ModFileName)), v.specializations) then
								allowInsertion12 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.Warningsseeder", ModFileName)), v.specializations) then
								allowInsertion12 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.warningsseeder", ModFileName)), v.specializations) then
								allowInsertion12 = false;
							end;

						end;
						if allowInsertion12 then
							table.insert(v.specializations, SpecializationUtil.getSpecialization("warningsSeeder"));
							table.insert(v.specializations, SpecializationUtil.getSpecialization("warningsDisabler"));
						end;
					end;
					if (vs == SpecializationUtil.getSpecialization("sprayer") or vs == SpecializationUtil.getSpecialization("Sprayer")) then
						local allowInsertion13 = true;
						local v_name_string = v.name
						local point_location = string.find(v_name_string, ".", nil, true)
						if point_location ~= nil then
							local ModFileName = string.sub(v_name_string, 1, point_location-1);
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.warningsFertilizer", ModFileName)), v.specializations) then
								allowInsertion13 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.WarningsFertilizer", ModFileName)), v.specializations) then
								allowInsertion13 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.Warningsfertilizer", ModFileName)), v.specializations) then
								allowInsertion13 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.warningsfertilizer", ModFileName)), v.specializations) then
								allowInsertion13 = false;
							end;

						end;
						if allowInsertion13 then
							table.insert(v.specializations, SpecializationUtil.getSpecialization("warningsFertilizer"));
							table.insert(v.specializations, SpecializationUtil.getSpecialization("warningsDisabler"));
						end;
					end;
					if vs == SpecializationUtil.getSpecialization("combine") then
						local allowInsertion14 = true;
						local v_name_string = v.name
						local point_location = string.find(v_name_string, ".", nil, true)
						if point_location ~= nil then
							local ModFileName = string.sub(v_name_string, 1, point_location-1);
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.warningsCombine", ModFileName)), v.specializations) then
								allowInsertion14 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.Warningscombine", ModFileName)), v.specializations) then
								allowInsertion14 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.warningscombine", ModFileName)), v.specializations) then
								allowInsertion14 = false;
							end;
							if SpecializationUtil.hasSpecialization(SpecializationUtil.getSpecialization(string.format("%s.WarningsCombine", ModFileName)), v.specializations) then
								allowInsertion14 = false;
							end;

						end;
						if allowInsertion14 then
							table.insert(v.specializations, SpecializationUtil.getSpecialization("warningsCombine"));
							table.insert(v.specializations, SpecializationUtil.getSpecialization("warningsDisabler"));
						end;
					end;
				  end;
				end;
			end;
		end;
	end;
end;
function WarningFunctions:deleteMap()
end;
function WarningFunctions:keyEvent(unicode, sym, modifier, isDown)
end;
function WarningFunctions:mouseEvent(posX, posY, isDown, isUp, button)
end;
function WarningFunctions:update(dt)
	if InputBinding.hasEvent(InputBinding.TOGGLE_HELP_TEXT) then
		-- 0  ->  HUDs anzeigen, Menhud an
		-- 1  ->  HUDs anzeigen, Menhud aus
		-- 2  ->  HUDs ausblenden, Menhud an
		-- 3  ->  HUDs ausblenden, Menhud aus
		g_currentMission.extraHudMode = g_currentMission.extraHudMode + 1;
		if g_currentMission.extraHudMode == 4 then
			g_currentMission.extraHudMode = 0;
		end;
	end;
end;
function WarningFunctions:draw()
end;

addModEventListener(WarningFunctions);
